<?php if (!defined('PmWiki')) exit();

define(PHPINC_BINDIR, 'phpinc/');
define(PHPINC_PERMPAGE, 'Site.PhpIncPermissions');

Markup('phpinc', '_begin', "/\\(:phpinc ([\\w\\-\\/]+)(| .*?):\\)/e",
  "phpinc_capture(PSS('$1'), PSS('$2'))");

$GLOBALS['phpinc_allow_exec'] = false;  # false = not yet initialized

# Begrenzer fr 4. Parameter mssen " sein, sonst schlgt PSS() fehl.

function phpinc_capture($phpinc_script, $phpinc_params)
{
  $phpinc_caller = $GLOBALS['pagename'];

  $phpinc_incfn = PHPINC_BINDIR . $phpinc_script . '.php';
  if (!file_exists($phpinc_incfn))
    { return "[error@phpinc@$phpinc_caller: 404 file not found: $phpinc_incfn]"; }

  global $phpinc_allow_exec;

  if ($phpinc_allow_exec === false)  # when called the first time, read permissions
  {
    $perms = ReadPage(PHPINC_PERMPAGE);
    $perms = (isset($perms['text']) ? explode("\n", (string)$perms['text']) : array());

    $phpinc_allow_exec = array('*' => array());
    $wikipage = '';

    foreach ($perms as $perm)
    {
      $scripts = explode(' ', trim($perm));
      $wikipage = array_shift($scripts);
      if (preg_match('!^:([^\s\.:]*\.[^\s\.:]*|\*):$!', $wikipage, $treffer))
      {
        $phpinc_allow_exec[$treffer[1]] = $scripts;
      }
    }
  }

  $allow_exec = false;
  if (in_array($phpinc_script, $phpinc_allow_exec['*']))
  {
    $allow_exec = true;
  }
  else
  {
    if (isset($phpinc_allow_exec[$phpinc_caller]))
    {
      $allow_exec = in_array($phpinc_script, $phpinc_allow_exec[$phpinc_caller]);
    }
  }

  if (!$allow_exec)
  {
    return ("[error@phpinc@$phpinc_caller: 403 execution [[" . PHPINC_PERMPAGE
      . "|denied]]: $phpinc_script]");
  }

  $phpinc_params = ParseArgs($phpinc_params);

  ob_start();
  include($phpinc_incfn);
  $content = ob_get_contents();
  ob_end_clean();

  return $content;
}


function phpinc_use_lib($fn)
{
  require_once (PHPINC_BINDIR . $fn);
}